hdr
format shorte;

for k=1:6;
  N=2^k; 

  m=N-1;
  h=1./N;

  xb = h*[0:N]'; x=xb(2:end-1);
  yb = h*[0:N]'; y=yb(2:end-1);

  Ax=tridiag(m)/(h*h); Ix=speye(m); ex=ones(m,1);
  Ay=tridiag(m)/(h*h); Iy=speye(m); ey=ones(m,1);

  Ax=full(Ax); [Sx,Lamx]=eig(Ax);  lamx=diag(Lamx); Sxi=inv(Sx);
  Ay=full(Ay); [Sy,Lamy]=eig(Ay);  lamy=diag(Lamy); Syi=inv(Sy);

  D = lamx*ey' + ex*lamy';  D=1./D;   %% Pointwise in wave-space!
  
  [X,Y]=ndgrid(x,y);
  [Xb,Yb]=ndgrid(xb,yb);  %% For plotting

  F = sin(pi*X).*sin(pi*Y);

  t0 = tic;
  Fh = Sxi*F*Syi';
  Uh = D.*Fh;
  U  = Sx*Uh*Sy';
  t1 = toc(t0);

  Uex = F./(2*pi*pi);

  err = Uex - U;



  enrm = max(max(abs(err)));

  disp([k N enrm])

  Rx=speye(m+2); Rx=Rx(2:end-1,:); 
  Ry=speye(m+2); Ry=Ry(2:end-1,:); 

  Ub = Rx'*U*Ry;
  mesh(Xb,Yb,Ub);
  title(num2str([k N enrm t1]),fs,20);
  xlabel('X',fs,20);
  ylabel('Y',fs,20);
  zlabel('U',fs,20);
  pause(.1);

end;





